//
//  AsP52N.h
//  P52NSDK
//
//  Created by MRX_ZYL on 13/10/2020.
//

#import <Foundation/Foundation.h>
@class AsP52N;
#pragma mark  ---P51N/P52N SDK COMMON ENUM---
typedef NS_ENUM(NSUInteger, AsP52NetworkState) {
    AsP52NetworkStateUnknown = 0,
    AsP52NetworkStateConnected,
    AsP52NetworkStateDisconnected,
    AsP52NetworkStateError,
};
typedef NS_ENUM(uint32_t, AsP52NSessionType) {
    AsP52NSessionType_S0 = 0,
    AsP52NSessionType_S1,
    AsP52NSessionType_S2,
    AsP52NSessionType_S3,
};
typedef NS_ENUM(uint32_t, AsP52NMemoryBankType) {
    AsP52NMemoryBankTypeReserved = 0,
    AsP52NMemoryBankTypeEPC,
    AsP52NMemoryBankTypeTID,
    AsP52NMemoryBankTypeUser,
};
typedef NS_ENUM(NSUInteger, AsP52NTargetMemoryType) {
    AsP52NTargetMemoryTypeKill = 0,
    AsP52NTargetMemoryTypeAccess,
    AsP52NTargetMemoryTypeEPC,
    AsP52NTargetMemoryTypeTID,
    AsP52NTargetMemoryTypeUser,
};
typedef NS_ENUM(NSUInteger, AsP52NLockActionType) {
    AsP52NLockActionTypeUnlock = 0,
    AsP52NLockActionTypeLock,
    AsP52NLockActionTypePermaUnlock,
    AsP52NLockActionTypePermaLock,
};
#pragma mark  ---P52N SDK ENUM---
typedef NS_ENUM(NSUInteger, AsP52NBasebandRateStatus) {
    AsP52NBasebandRateStatus40KHz = 0,
    AsP52NBasebandRateStatus250KHz,
    AsP52NBasebandRateStatus300KHz,
    AsP52NBasebandRateStatus400KHz,
    AsP52NBasebandRateStatus320KHz,
    AsP52NBasebandRateStatusAuto,
};
typedef NS_ENUM(NSUInteger, AsP52NInventoryFlag) {
    AsP52NInventoryFlag_A = 0,
    AsP52NInventoryFlag_B,
    AsP52NInventoryFlag_AB,
};
typedef NS_ENUM(NSUInteger, AsP52NRFIDFrequencyStatus) {
    AsP52NRFIDFrequencyStatus920_925MHz = 0,
    AsP52NRFIDFrequencyStatusFCC = 3,
    AsP52NRFIDFrequencyStatusETSI = 4,
    AsP52NRFIDFrequencyStatusJP = 10,
};
typedef NS_ENUM(NSUInteger, AsP52NExecutionStatus) {
    AsP52NExecutionStatusSuccess = 0,
    AsP52NExecutionStatusCommandExecutionError = 1,
    AsP52NExecutionStatusPacketSendFailed = 2,
    //TODO:ReadDataError
    AsP52NExecutionStatusReadDataLabelNotRespond =                      21,
    AsP52NExecutionStatusReadDataCRCError =                             22,
    AsP52NExecutionStatusReadDataAreaLocked =                           23,
    AsP52NExecutionStatusReadDataAreaOverflows =                        24,
    AsP52NExecutionStatusReadDataAccessPasswordError =                  25,
    AsP52NExecutionStatusReadDataOtherLabelsError =                     26,
    AsP52NExecutionStatusReadDataOtherReaderError =                     27,
    //TODO:WriteMemoryError
    AsP52NExecutionStatusWriteMemoryAntennaPortParameterError =         41,
    AsP52NExecutionStatusWriteMemorySelectedParameterError =            42,
    AsP52NExecutionStatusWriteMemoryWriteParameterError =               43,
    AsP52NExecutionStatusWriteMemoryCRCCheckError =                     44,
    AsP52NExecutionStatusWriteMemoryInsufficientPower =                 45,
    AsP52NExecutionStatusWriteMemoryDataAreaOverflow =                  46,
    AsP52NExecutionStatusWriteMemoryDataAreaLocked =                    47,
    AsP52NExecutionStatusWriteMemoryAccessPasswordError =               48,
    AsP52NExecutionStatusWriteMemoryOtherLabelError =                   49,
    AsP52NExecutionStatusWriteMemoryLabelMissing =                      50,
    AsP52NExecutionStatusWriteMemoryStatusCommandError =                51,
    //TODO:LockMemoryError
    AsP52NExecutionStatusLockMemoryAntennaPortError =                   61,
    AsP52NExecutionStatusLockMemorySelectedParameterError =             62,
    AsP52NExecutionStatusLockMemoryLockOperationParameterError =        63,
    AsP52NExecutionStatusLockMemoryaCRCCheckError =                     64,
    AsP52NExecutionStatusLockMemoryInsufficientPower =                  65,
    AsP52NExecutionStatusLockMemoryDataOverflow =                       66,
    AsP52NExecutionStatusLockMemoryaDataLocked =                        67,
    AsP52NExecutionStatusLockMemoryAccessPasswordError =                68,
    AsP52NExecutionStatusLockMemoryOtherLabelError =                    69,
    AsP52NExecutionStatusLockMemoryLabelMissing =                       70,
    AsP52NExecutionStatusLockMemoryCommandError =                       71,
    //TODO:KillMemoryError
    AsP52NExecutionStatusKillMemoryAntennaPortParameterError =          81,
    AsP52NExecutionStatusKillMemorySelectedParameterError =             82,
    AsP52NExecutionStatusKillMemoryCRCCheckError =                      83,
    AsP52NExecutionStatusKillMemoryInsufficientPower =                  84,
    AsP52NExecutionStatusKillMemoryInactivationPasswordError =          85,
    AsP52NExecutionStatusKillMemoryOtherLabelError =                    86,
    AsP52NExecutionStatusKillMemoryLabelMissing =                       87,
    AsP52NExecutionStatusKillMemoryInstructionError =                   88,
    //TODO:AntennaPowerError
    AsP52NExecutionStatusAntennaPowerPortParameterNotSupport =          101,
    AsP52NExecutionStatusAntennaPowerParameterNotSupport =              102,
    AsP52NExecutionStatusAntennaPowerSaveFailed =                       103,
    //TODO:AutoDormancyError
    AsP52NExecutionStatusAutoDormancyModeParameterErrors =              121,
    AsP52NExecutionStatusAutoDormancyOtherParameterErrors =             122,
    AsP52NExecutionStatusAutoDormancySaveFailed =                       123,
    //TODO:SetRFIDFrequencyError
    AsP52NExecutionStatusSetRFIDFrequencyBandParameterNotSupported =    141,
    AsP52NExecutionStatusSetRFIDFrequencySaveFailed =                   142,
    //TODO:TagLogError
    AsP52NExecutionStatusTagLogParameterError =                         161,
    AsP52NExecutionStatusTagLogSaveFailed =                             162,
    //TODO:FrequencyError
    AsP52NExecutionStatusFrequencyChannelNotInFrequencyBand =           181,
    AsP52NExecutionStatusFrequencyInvalidFrequencyPoints =              182,
    AsP52NExecutionStatusFrequencyOtherParameterErrors =                183,
    AsP52NExecutionStatusFrequencySaveFailed =                          184,
    //TODO:ReaderTimeError
    AsP52NExecutionStatusReaderTimeRTCSettingFailed =                   201,
    //TODO:EthernetIPError
    AsP52NExecutionStatusEthernetIPReaderIPParameterError =             221,
    //TODO:ClearCacheError
    AsP52NExecutionStatusClearCacheError =                              241,
    //TODO:FactoryResetError
    AsP52NExecutionStatusFactoryResetError =                            261,
    //TODO:InventoryError
    AsP52NExecutionStatusInventoryErrorAntennaPortParameterError =      281,
    AsP52NExecutionStatusInventoryErrorSelectionReadParameterError =    282,
    AsP52NExecutionStatusInventoryErrorTIDReadParameterError =          283,
    AsP52NExecutionStatusInventoryErrorUserDataAreaReadParameterError = 284,
    AsP52NExecutionStatusInventoryErrorReservedAreaReadParameterError = 285,
    AsP52NExecutionStatusInventoryErrorOtherParameterError =            286,
    //TODO:BasebandError
    AsP52NExecutionStatusBasebandRateNotSupported =                     301,
    AsP52NExecutionStatusBasebandQValueParameterError =                 302,
    AsP52NExecutionStatusBasebandSessionParameterError =                303,
    AsP52NExecutionStatusBasebandInventoryParameterError =              304,
    AsP52NExecutionStatusBasebandOtherParametersError =                 305,
    AsP52NExecutionStatusBasebandSaveFailed =                           306,
};
@protocol AsP52NDelegate <NSObject>
@optional
#pragma mark  ---P51N/P52N SDK COMMON DELEGATE---
/**
 *  @brief      The IP address of the device was received.
 *  @details    This delegate will be called back once the 'startSearchDevice' function is called.
 *  @param      AsP52N : AsP52N object.
 *
 *  @param      IP       : Device's IP address.
 *
 *  @param      isFinish : Search status.
 *                         YES:Search completed.
 *                         NO :Continue to search.
 */
- (void)AsP52N:(AsP52N *)AsP52N
   searchingIP:(NSString *)IP
      isFinish:(BOOL)isFinish;
/**
 *  @brief      The Network state was received.
 *  @details    This delegate will be called back when the network state changes.
 *  @param      AsP52N : AsP52N object.
 *  @param      state : The enumeration 'AsP52NetworkState'.
 *  @param      error : Error message that occurs when the network state changes.
 */
- (void)AsP52N:(AsP52N *)AsP52N
changeNetworkState:(AsP52NetworkState)state
         error:(NSError *)error;
/**
 *  @brief      This delegate will be called back once the 'startInventoryWithEPC' or 'readTagWithAccessPassword' or 'readDataWithAntenna1' or 'startInventoryWithAntenna1' or 'startInventoryTIDWithAntenna1' or 'startInventoryMoistureWithAntenna1' or 'startInventoryMagnusS3WithAntenna1'  function is called.
 *  @param      AsP52N   : AsP52N object.
 *
 *  @param      statusCode : The enumeration 'AsP52NExecutionStatus'.
 *                           If the value of statusCode is not 'AsP52NExecutionStatusSuccess', an error will occured.
 */
- (void)AsP52N:(AsP52N *)AsP52N
didStartInventoryExecutionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      This delegate will be called back once the 'stopInventory' or 'stopReadData' function is called.
 *  @param      AsP52N   : AsP52N object.
 *
 *  @param      statusCode : The enumeration 'AsP52NExecutionStatus'.
 *                           If the value of statusCode is not 'AsP52NExecutionStatusSuccess', an error will occured.
 */
- (void)AsP52N:(AsP52N *)AsP52N
didStopInventoryExecutionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The scanned tags information was received.
 *  @details    This delegate will be called back once the 'startInventoryWithEPC' function is called.
 *  @param      AsP52N : AsP52N object.
 *
 *  @param      RSSI     : RSSI data.
 *
 *  @param      channel  : Channel information.
 *
 *  @param      phase    : Phase information.
 *
 *  @param      antenna  : Antenna information.
 *
 *  @param      PC       : PC data.
 *
 *  @param      EPC      : EPC data.
 *
 *  @param      TID      : TID data.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedInventoryDataWithRSSI:(NSString *)RSSI
       channel:(NSString *)channel
         phase:(NSString *)phase
       antenna:(NSString *)antenna
            PC:(NSString *)PC
           EPC:(NSString *)EPC
           TID:(NSString *)TID;
/**
 *  @brief      This delegate will be called back once the 'killTagWithKillPassword' function is called.
 *  @param      AsP52N   : AsP52N object.
 *
 *  @param      statusCode : The enumeration 'AsP52NExecutionStatus'.
 *                          If statusCode is not AsP52NExecutionStatusSuccess, return error status code.
 */
- (void)AsP52N:(AsP52N *)AsP52N
didKillTagExecutionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      This delegate will be called back once the 'writeTagWithAccessPassword' function is called.
 *  @param      AsP52N   : AsP52N object.
 *
 *  @param      statusCode : The enumeration 'AsP52NExecutionStatus'.
 *                          If statusCode is not AsP52NExecutionStatusSuccess, return error status code.
 */
- (void)AsP52N:(AsP52N *)AsP52N
didWriteTagExecutionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      This delegate will be called back once the 'lockTagWithAccessPassword' function is called.
 *  @param      AsP52N   : AsP52N object.
 *
 *  @param      statusCode : The enumeration 'AsP52NExecutionStatus'.
 *                          If statusCode is not AsP52NExecutionStatusSuccess, return error status code.
 */
- (void)AsP52N:(AsP52N *)AsP52N
didLockTagExecutionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      This delegate will be called back once the 'readTagWithAccessPassword' function is called.
 *  @param      AsP52N   : AsP52N object.
 *
 *  @param      statusCode : The enumeration 'AsP52NExecutionStatus'.
 *                          If statusCode is not AsP52NExecutionStatusSuccess, return error status code.
 */
- (void)AsP52N:(AsP52N *)AsP52N
didReadTagExecutionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The readed tags information was received.
 *  @details    This delegate will be called back once the 'readTagWithAccessPassword' function is called.
 *  @param      AsP52N             : AsP52N object.
 *
 *  @param      tagOperationData     : readed data.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedTagOperationData:(NSData *)tagOperationData;
/**
 *  @brief      This delegate will be called back once the 'setAntennaPortsStatusWithAntenna1' function is called.
 *  @param      AsP52N   : AsP52N object.
 *  @param      statusCode : The enumeration 'AsP52NExecutionStatus'.
 *                          If statusCode is not AsP52NExecutionStatusSuccess, return error status code.
 */
- (void)AsP52N:(AsP52N *)AsP52N
didSetAntennaPortsStatusExecutionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      This delegate will be called back once the 'getAntennaPortsStatus' function is called.
 *  @param      AsP52N       : AsP52N object.
 *
 *  @param      antenna1IsOpen : YES:Antenna1 opened.
 *                               NO :Antenna1 closed.
 *
 *  @param      antenna2IsOpen : YES:Antenna2 opened.
 *                               NO :Antenna2 closed.
 *
 *  @param      antenna3IsOpen : YES:Antenna3 opened.
 *                               NO :Antenna3 closed.
 *
 *  @param      antenna4IsOpen : YES:Antenna4 opened.
 *                               NO :Antenna4 closed.
 *
 *  @param      antenna5IsOpen : YES:Antenna5 opened.
 *                               NO :Antenna5 closed.
 *
 *  @param      antenna6IsOpen : YES:Antenna6 opened.
 *                               NO :Antenna6 closed.
 *
 *  @param      antenna7IsOpen : YES:Antenna7 opened.
 *                               NO :Antenna7 closed.
 *
 *  @param      antenna8IsOpen : YES:Antenna8 opened.
 *                               NO :Antenna8 closed.
 *
 *  @param      statusCode     : The enumeration 'AsP52NExecutionStatus'.
 *                               If the value of statusCode is not 'AsP52NExecutionStatusSuccess', an error will occured, and the values of parameters 'antenna1IsOpen' and 'antenna2IsOpen' and 'antenna3IsOpen' and 'antenna4IsOpen' will be invalid.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedAntennaPortsStatusAntenna1:(BOOL)antenna1IsOpen
      antenna2:(BOOL)antenna2IsOpen
      antenna3:(BOOL)antenna3IsOpen
      antenna4:(BOOL)antenna4IsOpen
      antenna5:(BOOL)antenna5IsOpen
      antenna6:(BOOL)antenna6IsOpen
      antenna7:(BOOL)antenna7IsOpen
      antenna8:(BOOL)antenna8IsOpen
executionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      This delegate will be called back once the 'setOutputPowerLevel' or 'setReaderAntenna1Power' function is called.
 *  @param      AsP52N   : AsP52N object.
 *
 *  @param      statusCode : The enumeration 'AsP52NExecutionStatus'.
 *                           If the value of statusCode is not 'AsP52NExecutionStatusSuccess', an error will occured.
 */
- (void)AsP52N:(AsP52N *)AsP52N
didSetOutputPowerLevelExecutionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      This delegate will be called back once the 'getOutputPowerLevel'  or 'getReaderAntennaPower' function is called.
 *  @param      AsP52N         : AsP52N object.
 *
 *  @param      outputPowerLevel : Output power level.
 *
 *  @param      statusCode : The enumeration 'AsP52NExecutionStatus'.
 *                           If the value of statusCode is not 'AsP52NExecutionStatusSuccess', an error will occured,  and the value of parameter 'outputPowerLevel' will be invalid.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedOutputPowerLevel:(uint8_t)outputPowerLevel
executionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      This delegate will be called back once the 'setSession' or 'setReaderBasebandRate' function is called.
 *  @param      AsP52N   : AsP52N object.
 *
 *  @param      statusCode : The enumeration 'AsP52NExecutionStatus'.
 *                           If the value of statusCode is not 'AsP52NExecutionStatusSuccess', an error will occured.
 */
- (void)AsP52N:(AsP52N *)AsP52N
didSetSessionExecutionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      This delegate will be called back once the 'getSession' or 'getReaderBasebandInformation' function is called.
 *  @param      AsP52N   : AsP52N object.
 *
 *  @param      session    : The enumeration 'AsP52NSessionType'.
 *
 *  @param      statusCode : The enumeration 'AsP52NExecutionStatus'.
 *                           If the value of statusCode is not 'AsP52NExecutionStatusSuccess', an error will occured, and the value of parameter 'session' will be invalid.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedSession:(AsP52NSessionType)session
executionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      This delegate will be called back once the 'getFirmwareVersion' function is called.
 *  @param      AsP52N        : AsP52N object.
 *
 *  @param      firmwareVersion : Firmware version.
 *
 *  @param      statusCode      : The enumeration 'AsP52NExecutionStatus'.
 *                                If the value of statusCode is not 'AsP52NExecutionStatusSuccess', an error will occured, and the value of parameter 'firmwareVersion' will be invalid.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedFirmwareVersion:(NSString *)firmwareVersion
executionStatus:(AsP52NExecutionStatus)statusCode;
#pragma mark  ---P52N SDK DELEGATE---
/**
 *  @brief      This delegate will be called back once the 'startInventoryWithEPC' or 'readTagWithAccessPassword'  or 'readDataWithAntenna1' or 'startInventoryWithAntenna1' or 'startInventoryTIDWithAntenna1' or 'startInventoryMoistureWithAntenna1'  or 'startInventoryMagnusS3WithAntenna1'  function is called.
 *  @param      AsP52N   : AsP52N object.
 *
 *  @param      statusCode : The enumeration 'AsP52NExecutionStatus'.
 *                           If the value of statusCode is not 'AsP52NExecutionStatusSuccess', an error will occured.
 */
- (void)AsP52N:(AsP52N *)AsP52N
didInventoryEndExecutionStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The device information was received.
 *  @details    This delegate will be called back once the 'getReaderInfo' function is called.
 *  @param      AsP52N : AsP52N object.
 *
 *  @param      readerInfo      : Device information.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedReaderInfo:(NSDictionary *)readerInfo;
/**
 *  @brief      The device antenna power was received.
 *  @details    This delegate will be called back once the 'getOutputPowerLevel'  or 'getReaderAntennaPower' function is called.
 *  @param      AsP52N : AsP52N object.
 *
 *  @param      antenna1Power     : Antenna1 power data.
 *
 *  @param      antenna2Power     : Antenna2 power data.
 *
 *  @param      antenna3Power     : Antenna3 power data.
 *
 *  @param      antenna4Power     : Antenna4 power data.
 *
 *  @param      antenna5Power     : Antenna5 power data.
 *
 *  @param      antenna6Power     : Antenna6 power data.
 *
 *  @param      antenna7Power     : Antenna7 power data.
 *
 *  @param      antenna8Power     : Antenna8 power data.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedReaderAntenna1Power:(int)antenna1Power
 antenna2Power:(int)antenna2Power
 antenna3Power:(int)antenna3Power
 antenna4Power:(int)antenna4Power
 antenna5Power:(int)antenna5Power
 antenna6Power:(int)antenna6Power
 antenna7Power:(int)antenna7Power
 antenna8Power:(int)antenna8Power;
/**
 *  @brief      The device set antenna power status was received.
 *  @details    This delegate will be called back once the 'setOutputPowerLevel' or 'setReaderAntenna1Power' function is called.
 *  @param      AsP52N : AsP52N object.
 *
 *  @param      statusCode      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedSetAntennaPowerStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The device baseband was received.
 *  @details    This delegate will be called back once the 'getReaderBasebandInformation' or 'getSession' function is called.
 *  @param      AsP52N : AsP52N object.
 *
 *  @param      basebandRate      :   The enumeration 'AsP52NBasebandRateStatus'.
 *
 *  @param      qValue      :   Q value.(0~15)
 *
 *  @param      session      :  The enumeration 'AsP52NSessionType'.
 *
 *  @param      inventoryFlag      :   The enumeration 'AsP52NInventoryFlag'.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedReaderBasebandRate:(AsP52NBasebandRateStatus)basebandRate
        QValue:(int)qValue
       session:(AsP52NSessionType)session
 inventoryFlag:(AsP52NInventoryFlag)inventoryFlag;
/**
 *  @brief      The device set  baseband status was received.
 *  @details    This delegate will be called back once the 'setReaderBasebandRate'  or 'setSession' function is called.
 *  @param      AsP52N : AsP52N object.
 *
 *  @param      statusCode      : The enumeration 'AsP52NExecutionStatus'.
 *                             If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedSetBasebandStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The device auto dormancy was received.
 *  @details    This delegate will be called back once the 'getReaderAutoDormancy' function is called.
 *  @param      AsP52N : AsP52N object.
 *
 *  @param      autoDormancy      :   Whether to use auto dormancy.
 *                                 YES:Used.
 *                                 NO :Don't used.
 *
 *  @param      dormancyTime      :  The auto dormancy time.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedReaderAutoDormancy:(BOOL)autoDormancy
  dormancyTime:(int)dormancyTime;
/**
 *  @brief      The device set  auto dormancy status was received.
 *  @details    This delegate will be called back once the 'setReaderAutoDormancy' function is called.
 *  @param      statusCode      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedSetAutoDormancyStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The device RFID frequency was received.
 *  @details    This delegate will be called back once the 'getReaderRFIDFrequency' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      frequency      :  The enumeration 'AsP52NRFIDFrequencyStatus'.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedReaderRFIDFrequency:(AsP52NRFIDFrequencyStatus)frequency;
/**
 *  @brief      The device set  RFID frequency status was received.
 *  @details    This delegate will be called back once the 'setReaderRFIDFrequency' function is called.
 *  @param      statusCode      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedSetRFIDFrequencyStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The device tag Log was received.
 *  @details    This delegate will be called back once the 'getReaderTagLog' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      filtertime      :   Duplicate label filtering time.
 *
 *  @param      rssi      :  RSSI threshold.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedReaderTagLogFilterTime:(int)filtertime
          RSSI:(int)rssi;
/**
 *  @brief      The device set  tag Log status was received.
 *  @details    This delegate will be called back once the 'setReaderTagLogFilterTime' function is called.
 *  @param      statusCode      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedSetTagLogStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The device frequency was received.
 *  @details    This delegate will be called back once the 'getReaderFrequency' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      frequencyAutomatic      :   Whether to use frequency automatic.
 *                                       YES:Used.
 *                                       NO :Don't used.
 *
 *  @param      frequencyList      :  Frequency list.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedReaderFrequencyAutomatic:(BOOL)frequencyAutomatic
 frequencyList:(NSString *)frequencyList;
/**
 *  @brief      The device set frequency status was received.
 *  @details    This delegate will be called back once the 'setReaderFrequencyAutomatic' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      statusCode      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedSetFrequencyStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The device Ethernet MAC was received.
 *  @details    This delegate will be called back once the 'getReaderEthernetMacAddress' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      ethernetMACAddress      :  Ethernet MAC address.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedReaderEthernetMACAddress:(NSString *)ethernetMACAddress;
/**
 *  @brief      The Reader time was received.
 *  @details    This delegate will be called back once the 'getReaderTime' function is called.
 *  @param      readerTime      :  Reader time.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedReaderTime:(NSString *)readerTime;
/**
 *  @brief      The device set Reader time status was received.
 *  @details    This delegate will be called back once the 'setReaderTime' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      statusCode      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedSetReaderTimeStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The Ethernet IP was received.
 *  @details    This delegate will be called back once the 'getReaderEthernetIP' function is called.
 *  @param      ip      :  IP address.
 *
 *  @param      subnetMask      :  Subnet mask.
 *
 *  @param      defaultGateway      :  Default gateway.
 *
 *  @param      preferredDNS      :  Preferred DNS.
 *
 *  @param      alternateDNS      :  Alternate DNS.
 *
 *  @param      automaticIP      :  Whether to get static IP automatic.
 *                               YES:Automatic.
 *                               NO :Don't automatic.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedReaderEthernetIP:(NSString *)ip
    subnetMask:(NSString *)subnetMask
defaultGateway:(NSString *)defaultGateway
  preferredDNS:(NSString *)preferredDNS
  alternateDNS:(NSString *)alternateDNS
   automaticIP:(BOOL)automaticIP;
/**
 *  @brief      The device set Ethernet IP status was received.
 *  @details    This delegate will be called back once the 'setReaderEthernetIP' or 'setDHCPForMACAddress' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      statusCode      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedSetEthernetIPStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The reader factory reset status was received.
 *  @details    This delegate will be called back once the 'factoryReset' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      statusCode      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedFactoryResetStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The reader inventory status was received.
 *  @details    This delegate will be called back once the 'startInventoryWithEPC' or 'readTagWithAccessPassword'  or 'readDataWithAntenna1' or 'startInventoryWithAntenna1' or 'startInventoryTIDWithAntenna1' or 'startInventoryMoistureWithAntenna1' or 'startInventoryMagnusS3WithAntenna1'  function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      statusCode      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedInventoryStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      The Data  scanned tags information was received.
 *  @details    This delegate will be called back once the 'startInventoryWithEPC' or 'readTagWithAccessPassword'  or 'readDataWithAntenna1' or 'startInventoryWithAntenna1' or 'startInventoryTIDWithAntenna1' or 'startInventoryMoistureWithAntenna1' or 'startInventoryMagnusS3WithAntenna1'  function is called.
 *  @param      AsP52N : AsP52N object.
 *
 *  @param      RSSI     : RSSI data.
 *
 *  @param      channel  : Channel information.
 *
 *  @param      phase    : Phase information.
 *
 *  @param      antenna  : Antenna information.
 *
 *  @param      PC       : PC data.
 *
 *  @param      EPC      : EPC data.
 *
 *  @param      TID      : TID data.
 *
 *  @param      userData      : UserData data.
 *
 *  @param      reserved      : Reserved data.
 *
 *  @param      epcBank      : EPC bank data.
 *
 *  @param      moisture      : Moisture data.
 *
 *  @param      temperature      : Temperature data.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedInventoryCustomDataWithRSSI:(NSString *)RSSI
       channel:(NSString *)channel
         phase:(NSString *)phase
       antenna:(NSString *)antenna
            PC:(NSString *)PC
           EPC:(NSString *)EPC
           TID:(NSString *)TID
      userData:(NSString *)userData
      reserved:(NSString *)reserved
       epcBank:(NSString *)epcBank
      moisture:(NSString *)moisture
   temperature:(NSString *)temperature;
/**
 *  @brief      The device write data status was received.
 *  @details    This delegate will be called back once the 'writeDataWithAntenna1' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      statusCode      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedWriteDataStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      Tag data reading status was received.
 *  @details    This delegate will be called back once the 'readDataWithAntenna1' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      statusCode      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedReadDataStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      Tag data lock status was received.
 *  @details    This delegate will be called back once the 'lockTagWithAntenna1' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      statusCode      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedLockDataStatus:(AsP52NExecutionStatus)statusCode;
/**
 *  @brief      Tag data kill status was received.
 *  @details    This delegate will be called back once the 'killTagWithAntenna1' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      statuCodes      :  The enumeration 'AsP52NExecutionStatus'.
 *                              If status code is not AsP52NExecutionStatusSuccess, return error status code
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedKillDataStatus:(AsP52NExecutionStatus)statuCodes;
/**
 *  @brief      Unknow command was received.
 *  @details    This delegate will be called back once received unknow command .
 *  @param      AsP52N : AsP52N object.
 *  @param      data      :  Unknow command data.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedUnknowCommand:(NSData *)data;
/**
 *  @brief      Error was received.
 *  @details    This delegate will be called back once the  system 'catch' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      error      :  Error.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedUnknowError:(NSError *)error;
/**
 *  @brief      The device temperature was received.
 *  @details    This delegate will be called back once the device temperature rise.
 *  @param      AsP52N : AsP52N object.
 *  @param      alarmTemperature      :  Alarm temperature.
 *  @param      currentTemperature      :  Current temperature.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedAlarmTemperature:(NSString *)alarmTemperature
currentTemperature:(NSString *)currentTemperature;
/**
 *  @brief      The device temperature was received.
 *  @details    This delegate will be called back once the 'getTemperature' function is called.
 *  @param      AsP52N : AsP52N object.
 *  @param      alarmTemperature      :  Alarm temperature.
 *  @param      currentTemperature      :  Current temperature.
 */
- (void)AsP52N:(AsP52N *)AsP52N
receivedGetTemperatureAlarmTemperature:(NSString *)alarmTemperature
currentTemperature:(NSString *)currentTemperature;

@end

@interface AsP52N : NSObject
@property(nonatomic, assign) id<AsP52NDelegate> delegate;
@property(nonatomic, assign, readonly)BOOL isConnected;
#pragma mark  ---P51N/P52N SDK COMMON METHOD---
/**
 *  @brief      AsP52N Singleton
 *  @return     AsP52N object
 */
+ (AsP52N *)sharedInstance;
/**
 *  @brief      Get SDK version.
 *  @return     SDK version.
 */
- (NSString *)getSDKVersion;
/**
 *  @brief      Search device.
 *  @return     Perform successed return null.
 *              Perform failure return NSError.
 */
- (NSError *)startSearchDevice;
/**
 *  @brief      Stop search device.
 *  @return     Perform successed return null.
 *              Perform failure return NSError.
 */
- (NSError *)stopSearchDevice;
/**
 *  @brief      Connect device.
 *  @param      IP   : The IP address of the device.
 *  @param      port : The port of the device.
 *  @return     Perform successed return null.
 *              Perform failure return NSError.
 */
- (NSError *)connectServerWithIP:(NSString *)IP remoteport:(int)port;
/**
 *  @brief      Disconnect device.
 *  @return     Perform successed return null.
 *              Perform failure return NSError.
 */
- (NSError *)disconnectServer;
/**
 *  @brief      Start inventory.
 *  @details    Read RFID tags.
 *  @param      EPC      : Whether EPC data is receive.
 *                         YES:Receive
 *                         NO :Don't receive.
 *
 *  @param      TID      : Whether TID data is receive.
 *                         YES:Receive
 *                         NO :Don't receive.
 *
 *  @param      PC      : Whether PC data is receive.
 *                        YES:Receive
 *                        NO :Don't receive.
 *
 *  @param      RSSI    : Whether RSSI data is receive.
 *                        YES:Receive
 *                        NO :Don't receive.
 *
 *  @param      phase   : Whether phase information is receive.
 *                        YES:Receive
 *                        NO :Don't receive.
 *
 *  @param      channel : Whether channel information is receive.
 *                        YES:Receive
 *                        NO :Don't receive.
 *
 *  @param      antenna : Whether antenna information is received.
 *                        YES:Receive
 *                        NO :Don't receive.
 */
- (void)startInventoryWithEPC:(BOOL)EPC
                          TID:(BOOL)TID
                           PC:(BOOL)PC
                         RSSI:(BOOL)RSSI
                        phase:(BOOL)phase
                      channel:(BOOL)channel
                      antenna:(BOOL)antenna;
/**
 *  @brief      Stop inventory.
 */
- (void)stopInventory;
/**
 *  @brief      Send the 'Read tag' command to the device.
 *  @details    Read tag data from specified memory bank.
 *  @param      accessPassword : If target memory bank was password protected.
 *                               Otherwise, set Access Password to 0x00000000.
 *
 *  @param      EPC            : Target tag’s EPC.
 *
 *  @param      memoryBank     : The enumeration 'AsP52NMemoryBankType'.
 *
 *  @param      startAddress   : Starting address.
 *
 *  @param      dataLength     : Data Length.
 */
- (void)readTagWithAccessPassword:(uint32_t)accessPassword
                              EPC:(NSData *)EPC
                       memoryBank:(AsP52NMemoryBankType)memoryBank
                     startAddress:(uint16_t)startAddress
                       dataLength:(uint16_t)dataLength;
/**
 *  @brief      Send the 'Write Tag' command to the device.
 *  @details    Write tag data.
 *  @param      accessPassword : If target memory bank was password protected.
 *                               Otherwise, set Access Password to 0x00000000.
 *
 *  @param      EPC            : Target tag’s EPC.
 *
 *  @param      memoryBank     : The enumeration 'AsP52NMemoryBankType'.
 *
 *  @param      startAddress   : Starting address.
 *
 *  @param      writeData      : Data to write.
 */
- (void)writeTagWithAccessPassword:(uint32_t)accessPassword
                               EPC:(NSData *)EPC
                        memoryBank:(AsP52NMemoryBankType)memoryBank
                      startAddress:(uint16_t)startAddress
                         writeData:(NSData *)writeData;
/**
 *  @brief      Send the 'Lock tag' command to the device.
 *  @details    Lock an indicated memory bank in the tag.
 *  @param      accessPassword : If memory bank was password protected.
 *                               Otherwise, set Access Password to 0x00000000.
 *
 *  @param      EPC            : Target tag’s EPC.
 *
 *  @param      targetMemory   : The enumeration 'AsP52NTargetMemoryType'.
 *
 *  @param      lockAction     : The enumeration 'AsP52NLockActionType'.
 */
- (void)lockTagWithAccessPassword:(uint32_t)accessPassword
                              EPC:(NSData *)EPC
                     targetMemory:(AsP52NTargetMemoryType)targetMemory
                       lockAction:(AsP52NLockActionType)lockAction;
/**
 *  @brief      Send the 'Kill tag' command to the device.
 *  @details    Kill a Tag.
 *  @param      killPassword : If Kill Password is set to 0x00000000.This command does not work.The target tag ignores it.
 *
 *  @param      EPC          : Target tag’s EPC.
 */
- (void)killTagWithKillPassword:(uint32_t)killPassword
                            EPC:(NSData *)EPC;
/**
 *  @brief      Set antenna ports status.
 *  @details    The sequence of antennas through which the reader will cycle.
 *  @param      antenna1IsOpen : YES:Open.
 *                               NO :Close.
 *
 *  @param      antenna2IsOpen : YES:Open.
 *                               NO :Close.
 *
 *  @param      antenna3IsOpen : YES:Open.
 *                               NO :Close.
 *
 *  @param      antenna4IsOpen : YES:Open.
 *                               NO :Close.
 *
 *  @param      antenna5IsOpen : YES:Open.
 *                               NO :Close.
 *
 *  @param      antenna6IsOpen : YES:Open.
 *                               NO :Close.
 *
 *  @param      antenna7IsOpen : YES:Open.
 *                               NO :Close.
 *
 *  @param      antenna8IsOpen : YES:Open.
 *                               NO :Close.
 *
 */
- (void)setAntennaPortsStatusWithAntenna1:(BOOL)antenna1IsOpen
                                 antenna2:(BOOL)antenna2IsOpen
                                 antenna3:(BOOL)antenna3IsOpen
                                 antenna4:(BOOL)antenna4IsOpen
                                 antenna5:(BOOL)antenna5IsOpen
                                 antenna6:(BOOL)antenna6IsOpen
                                 antenna7:(BOOL)antenna7IsOpen
                                 antenna8:(BOOL)antenna8IsOpen;
/**
 *  @brief      Get antenna ports status.
 */
- (void)getAntennaPortsStatus;
/**
 *  @brief      Send the 'Set output power level' command to the device
 *  @param      powerLevel : The powerLevel range is 0-36.
 */
- (void)setOutputPowerLevel:(uint32_t)powerLevel;
- (void)getOutputPowerLevel;
/**
 *  @brief      Send the 'Set session' command to the device
 *  @details    Determines which session the reader will use for tag population management.
 *  @param      session :The enumeration 'AsP52NSessionType'
 */
- (void)setSession:(AsP52NSessionType)session;
- (void)getSession;
/**
 *  @brief      Set DHCP.
 *  @param      MACAddress : MAC address
 *  @return     Set successed return YES.
 *              Set failure return NO.
 */
- (BOOL)setDHCPForMACAddress:(NSString *)MACAddress;
/**
 *  @brief      Set DHCP.
 *  @param      MACAddress : MAC address.
 *  @param      IP         : IP address.
 *  @param      subnet     : Subnet mask.
 *  @param      gateway    : Gateway.
 *  @param      DNSServer  : DNS.
 *  @return     Set successed return YES.
 *              Set failure return NO.
 */
- (BOOL)setDHCPForMACAddress:(NSString *)MACAddress
                          IP:(NSString *)IP
                      subnet:(NSString *)subnet
                     gateway:(NSString *)gateway
                   DNSServer:(NSString *)DNSServer;
/**
 *  @brief      Get firmware version.
 */
- (void)getFirmwareVersion;
#pragma mark  ---P52N SDK METHOD---
/**
 *  @brief      Status code conversion description text.
 *
 *  @param      resultCode      :  The enumeration 'AsP52NExecutionStatus'.
 *
 *  @return     Description text.
 */
- (NSString *)getMessageWithResultCode:(AsP52NExecutionStatus)resultCode;
/**
 *  @brief      Set timeout of search device.
 *  @param      timeout   : The maximum search time.(10~60s)
 */
- (void)setSearchDeviceTimeout:(NSTimeInterval)timeout;
/**
 *  @brief      Start inventory customize.
 *  @details    Read RFID tags.
 *  @param      antenna1      : Whether to use antenna 1 to read data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna2      :  Whether to use antenna 2 to read data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna3      :  Whether to use antenna 3 to read data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna4      :  Whether to use antenna 4 to read data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna5      :  Whether to use antenna 5 to read data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna6      :  Whether to use antenna 6 to read data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna7      :  Whether to use antenna 7 to read data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna8      :  Whether to use antenna 8 to read data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      isContinueScan : Whether antenna information is received.
 *                         YES:Receive
 *                         NO :Don't receive.
 *  @param      isUsedTID : Whether TID data is received.
 *                         YES:Receive
 *                         NO :Don't receive.
 *  @param      isUsedTidLength : Whether to use TID length .
 *                         YES:Used
 *                         NO :Don't used.
 *  @param      tidLength : Read length of TID data.
 *
 *  @param      isUsedUserData : Whether userData data is received.
 *                         YES:Receive
 *                         NO :Don't receive.
 *  @param      userDataOffset : Start address of userData data.
 *
 *  @param      userDataLength : Read length of userData data.
 *
 *  @param      isUsedReserved : Whether reserved data is received.
 *                         YES:Receive
 *                         NO :Don't receive.
 *  @param      reservedOffset : Start address of reserved data.
 *
 *  @param      reservedLength : Read length of reserved data.
 *
 *  @param      isUsedPassword : Whether  password is received.
 *                         YES:Receive
 *                         NO :Don't receive.
 *  @param      accessPassword : Password.
 *
 *  @param      isUsedMonza : Whether  Monza  QT Peek is received.
 *                         YES:Receive
 *                         NO :Don't receive.
 *  @param      isUsedRfmicron : Whether  Rfmicron temperature sensor is received.
 *                         YES:Receive
 *                         NO :Don't receive.
 *  @param      isUsedEMSensor : Whether  Em sensor data is received.
 *                         YES:Receive
 *                         NO :Don't receive.
 *  @param      isUsedEPC : Whether epc data is received.
 *                         YES:Receive
 *                         NO :Don't receive.
 *  @param      epcOffset : Start address of epc data.
 *
 *  @param      epcLength : Read length of epc data.
 *
 *  @param      isUsedMatch :  Whether to use match data.
 *                         YES:Match.
 *                         NO :Don't match.
 *
 *  @param      matchMemoryBankType : The enumeration 'AsP52NMemoryBankType'.(Only the last three items of the enumeration can be used)
 *
 *  @param      matchData : Current data.
 *
 *  @param      matchStartAddress : Current starting address.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)readDataWithAntenna1:(BOOL)antenna1
                    antenna2:(BOOL)antenna2
                    antenna3:(BOOL)antenna3
                    antenna4:(BOOL)antenna4
                    antenna5:(BOOL)antenna5
                    antenna6:(BOOL)antenna6
                    antenna7:(BOOL)antenna7
                    antenna8:(BOOL)antenna8
              isContinueScan:(BOOL)isContinueScan
                   isUsedTID:(BOOL)isUsedTID
             isUsedTidLength:(BOOL)isUsedTidLength
                   tidLength:(int)tidLength
              isUsedUserData:(BOOL)isUsedUserData
              userDataOffset:(int)userDataOffset
              userDataLength:(int)userDataLength
              isUsedReserved:(BOOL)isUsedReserved
              reservedOffset:(int)reservedOffset
              reservedLength:(int)reservedLength
              isUsedPassword:(BOOL)isUsedPassword
              accessPassword:(NSString *)accessPassword
                 isUsedMonza:(BOOL)isUsedMonza
              isUsedRfmicron:(BOOL)isUsedRfmicron
              isUsedEMSensor:(BOOL)isUsedEMSensor
                   isUsedEPC:(BOOL)isUsedEPC
                   epcOffset:(int)epcOffset
                   epcLength:(int)epcLength
                 isUsedMatch:(BOOL)isUsedMatch
         matchMemoryBankType:(AsP52NMemoryBankType)matchMemoryBankType
                   matchData:(NSString *)matchData
           matchStartAddress:(uint16_t)matchStartAddress;
/**
 *  @brief      Write data.
 *  @param      antenna1      : Whether to use antenna 1 to write data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna2      :  Whether to use antenna 2 to write data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna3      :  Whether to use antenna 3 to write data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna4      :  Whether to use antenna 4 to write data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna5      :  Whether to use antenna 5 to write data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna6      :  Whether to use antenna 6 to write data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna7      :  Whether to use antenna 7 to write data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna8      :  Whether to use antenna 8 to write data.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      writeMemoryBankType : The enumeration 'AsP52NMemoryBankType'.
 *
 *  @param      writeData : Current data.
 *
 *  @param      writeStartAddress : Current starting address.
 *
 *  @param      isUsedMatch :  Whether to use match data.
 *                         YES:Match.
 *                         NO :Don't match.
 *
 *  @param      matchMemoryBankType : The enumeration 'AsP52NMemoryBankType'.(Only the last three items of the enumeration can be used)
 *
 *  @param      matchData : Data to write.
 *
 *  @param      matchStartAddress : Starting writed address.
 *
 *  @param      accessPassword : Password.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)writeDataWithAntenna1:(BOOL)antenna1
                     antenna2:(BOOL)antenna2
                     antenna3:(BOOL)antenna3
                     antenna4:(BOOL)antenna4
                     antenna5:(BOOL)antenna5
                     antenna6:(BOOL)antenna6
                     antenna7:(BOOL)antenna7
                     antenna8:(BOOL)antenna8
          writeMemoryBankType:(AsP52NMemoryBankType)writeMemoryBankType
                    writeData:(NSString *)writeData
            writeStartAddress:(uint16_t)writeStartAddress
                  isUsedMatch:(BOOL)isUsedMatch
          matchMemoryBankType:(AsP52NMemoryBankType)matchMemoryBankType
                    matchData:(NSString *)matchData
            matchStartAddress:(uint16_t)matchStartAddress
               accessPassword:(NSString *)accessPassword;
/**
 *  @brief      Send the 'Lock tag' command to the device.
 *  @details    Lock a Tag.
 *  @param      antenna1      : Whether to use antenna 1 to lock tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna2      :  Whether to use antenna 2 to  lock tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna3      :  Whether to use antenna 3 to lock tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna4      :  Whether to use antenna 4 to lock tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna5      :  Whether to use antenna 5 to  lock tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna6      :  Whether to use antenna 6 to  lock tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna7      :  Whether to use antenna 7 to  lock tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna8      :  Whether to use antenna 8 to  lock tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      targetMemory      :  The enumeration 'AsP52NTargetMemoryType'.
 *
 *  @param      lockAction      :   The enumeration 'AsP52NLockActionType'.
 *
 *  @param      isUsedMatch :  Whether to use match data.
 *                         YES:Match.
 *                         NO :Don't match.
 *
 *  @param      matchMemoryBankType : The enumeration 'AsP52NMemoryBankType'.(Only the last three items of the enumeration can be used)
 *
 *  @param      matchData : Data to write.
 *
 *  @param      matchStartAddress : Starting writed address.
 *
 *  @param      accessPassword : Password.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)lockTagWithAntenna1:(BOOL)antenna1
                   antenna2:(BOOL)antenna2
                   antenna3:(BOOL)antenna3
                   antenna4:(BOOL)antenna4
                   antenna5:(BOOL)antenna5
                   antenna6:(BOOL)antenna6
                   antenna7:(BOOL)antenna7
                   antenna8:(BOOL)antenna8
               targetMemory:(AsP52NTargetMemoryType)targetMemory
                 lockAction:(AsP52NLockActionType)lockAction
                isUsedMatch:(BOOL)isUsedMatch
        matchMemoryBankType:(AsP52NMemoryBankType)matchMemoryBankType
                  matchData:(NSString *)matchData
          matchStartAddress:(uint16_t)matchStartAddress
             accessPassword:(NSString *)accessPassword;
/**
 *  @brief      Send the 'Kill tag' command to the device.
 *  @details    Kill a Tag.
 *  @param      antenna1      : Whether to use antenna 1 to kill tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna2      :  Whether to use antenna 2 to  kill tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna3      :  Whether to use antenna 3 to kill tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna4      :  Whether to use antenna 4 to kill tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna5      :  Whether to use antenna 5 to  kill tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna6      :  Whether to use antenna 6 to  kill tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna7      :  Whether to use antenna 7 to  kill tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna8      :  Whether to use antenna 8 to  kill tag.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      killPassword : If Kill Password is set to 0x00000000.This command does not work.The target tag ignores it.
 *
 *  @param      isUsedMatch :  Whether to use match data.
 *                         YES:Match.
 *                         NO :Don't match.
 *
 *  @param      matchMemoryBankType : The enumeration 'AsP52NMemoryBankType'.(Only the last three items of the enumeration can be used)
 *
 *  @param      matchData : Data to write.
 *
 *  @param      matchStartAddress : Starting writed address.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)killTagWithAntenna1:(BOOL)antenna1
                   antenna2:(BOOL)antenna2
                   antenna3:(BOOL)antenna3
                   antenna4:(BOOL)antenna4
                   antenna5:(BOOL)antenna5
                   antenna6:(BOOL)antenna6
                   antenna7:(BOOL)antenna7
                   antenna8:(BOOL)antenna8
               killPassword:(NSString *)killPassword
                isUsedMatch:(BOOL)isUsedMatch
        matchMemoryBankType:(AsP52NMemoryBankType)matchMemoryBankType
                  matchData:(NSString *)matchData
          matchStartAddress:(uint16_t)matchStartAddress;
/**
 *  @brief      Start inventory.
 *  @details    Read RFID tags.
 *  @param      antenna1      : Whether to use antenna 1 to read EPC.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna2      :  Whether to use antenna 2 to read EPC.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna3      :  Whether to use antenna 3 to read EPC.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna4      :  Whether to use antenna 4 to read EPC.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna5      :  Whether to use antenna 5 to read EPC.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna6      :  Whether to use antenna 6 to read EPC.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna7      :  Whether to use antenna 7 to read EPC.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna8      :  Whether to use antenna 8 to read EPC.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      isContinueScan : Whether antenna information is received.
 *                        YES:Receive
 *                        NO :Don't receive.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)startInventoryWithAntenna1:(BOOL)antenna1
                          antenna2:(BOOL)antenna2
                          antenna3:(BOOL)antenna3
                          antenna4:(BOOL)antenna4
                          antenna5:(BOOL)antenna5
                          antenna6:(BOOL)antenna6
                          antenna7:(BOOL)antenna7
                          antenna8:(BOOL)antenna8
                    isContinueScan:(BOOL)isContinueScan;
/**
 *  @brief      Start TID inventory.
 *  @details    Read RFID tags.
 *  @param      antenna1      : Whether to use antenna 1 to read TID.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna2      :  Whether to use antenna 2 to read TID.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna3      :  Whether to use antenna 3 to read TID.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna4      :  Whether to use antenna 4 to read TID.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna5      :  Whether to use antenna 5 to read TID.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna6      :  Whether to use antenna 6 to read TID.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna7      :  Whether to use antenna 7 to read TID.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna8      :  Whether to use antenna 8 to read TID.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      isContinueScan : Whether antenna information is received.
 *                        YES:Receive
 *                        NO :Don't receive.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)startInventoryTIDWithAntenna1:(BOOL)antenna1
                             antenna2:(BOOL)antenna2
                             antenna3:(BOOL)antenna3
                             antenna4:(BOOL)antenna4
                             antenna5:(BOOL)antenna5
                             antenna6:(BOOL)antenna6
                             antenna7:(BOOL)antenna7
                             antenna8:(BOOL)antenna8
                       isContinueScan:(BOOL)isContinueScan;
/**
 *  @brief      Start Moisture inventory.
 *  @details    Read RFID tags.
 *  @param      antenna1      : Whether to use antenna 1 to read moisture.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna2      :  Whether to use antenna 2 to read moisture.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna3      :  Whether to use antenna 3 to read moisture.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna4      :  Whether to use antenna 4 to read moisture.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna5      :  Whether to use antenna 5 to read moisture.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna6      :  Whether to use antenna 6 to read moisture.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna7      :  Whether to use antenna 7 to read moisture.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna8      :  Whether to use antenna 8 to read moisture.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      isContinueScan : Whether antenna information is received.
 *                        YES:Receive
 *                        NO :Don't receive.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)startInventoryMoistureWithAntenna1:(BOOL)antenna1
                                  antenna2:(BOOL)antenna2
                                  antenna3:(BOOL)antenna3
                                  antenna4:(BOOL)antenna4
                                  antenna5:(BOOL)antenna5
                                  antenna6:(BOOL)antenna6
                                  antenna7:(BOOL)antenna7
                                  antenna8:(BOOL)antenna8
                            isContinueScan:(BOOL)isContinueScan;
/**
 *  @brief      Start MagnusS3 inventory.
 *  @details    Read RFID tags.
 *  @param      antenna1      : Whether to use antenna 1 to read MagnusS3.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna2      :  Whether to use antenna 2 to read MagnusS3.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna3      :  Whether to use antenna 3 to read MagnusS3.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna4      :  Whether to use antenna 4 to read MagnusS3.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna5      :  Whether to use antenna 5 to read MagnusS3.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna6      :  Whether to use antenna 6 to read MagnusS3.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna7      :  Whether to use antenna 7 to read MagnusS3.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      antenna8      :  Whether to use antenna 8 to read MagnusS3.
 *                         YES:Used.
 *                         NO :Don't used.
 *
 *  @param      isContinueScan : Whether antenna information is received.
 *                        YES:Receive
 *                        NO :Don't receive.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)startInventoryMagnusS3WithAntenna1:(BOOL)antenna1
                                  antenna2:(BOOL)antenna2
                                  antenna3:(BOOL)antenna3
                                  antenna4:(BOOL)antenna4
                                  antenna5:(BOOL)antenna5
                                  antenna6:(BOOL)antenna6
                                  antenna7:(BOOL)antenna7
                                  antenna8:(BOOL)antenna8
                            isContinueScan:(BOOL)isContinueScan;
/**
 *  @brief      Stop read data.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)stopReadData;
/**
 *  @brief      Set up continuous scan.
 *
 *  @param      isContinueScan      : Whether to scan continuously when scanning.
 *                               YES:Continuous sweep.
 *                               NO :Single scan.
 */
- (void)setScanContinuous:(BOOL)isContinueScan;
/**
 *  @brief      Get device information.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)getReaderInfo;
/**
 *  @brief      Get device antenna power.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)getReaderAntennaPower;
/**
 *  @brief      Set device antenna power.
 *  @param      antenna1Power      :  Antenna1 power data.(0~36)
 *
 *  @param      antenna2Power      :  Antenna2 power data.(0~36)
 *
 *  @param      antenna3Power      :  Antenna3 power data.(0~36)
 *
 *  @param      antenna4Power      :  Antenna4 power data.(0~36)
 *
 *  @param      antenna5Power      :  Antenna5 power data.(0~36)
 *
 *  @param      antenna6Power      :  Antenna6 power data.(0~36)
 *
 *  @param      antenna7Power      :  Antenna7 power data.(0~36)
 *
 *  @param      antenna8Power      :  Antenna8 power data.(0~36)
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)setReaderAntenna1Power:(int)antenna1Power
                 antenna2Power:(int)antenna2Power
                 antenna3Power:(int)antenna3Power
                 antenna4Power:(int)antenna4Power
                 antenna5Power:(int)antenna5Power
                 antenna6Power:(int)antenna6Power
                 antenna7Power:(int)antenna7Power
                 antenna8Power:(int)antenna8Power;
/**
 *  @brief      Get device baseband.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)getReaderBasebandInformation;

/**
 *  @brief      Set device baseband.
 *  @param      basebandRate      :   The enumeration 'AsP52NBasebandRateStatus'.
 *
 *  @param      qValue      :   Q value.(0~15)
 *
 *  @param      session      :  The enumeration 'AsP52NSessionType'.
 *
 *  @param      inventoryFlag      :   The enumeration 'AsP52NInventoryFlag'.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)setReaderBasebandRate:(AsP52NBasebandRateStatus)basebandRate
                       QValue:(int)qValue
                      session:(AsP52NSessionType)session
                inventoryFlag:(AsP52NInventoryFlag)inventoryFlag;
/**
 *  @brief      Get device auto dormancy.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)getReaderAutoDormancy;
/**
 *  @brief      Set device auto dormancy.
 *  @param      autoDormancy      :   Whether to use auto dormancy.
 *                                 YES:Used.
 *                                 NO :Don't used.
 *
 *  @param      time      :  The auto dormancy time.(0~65535)
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)setReaderAutoDormancy:(BOOL)autoDormancy
                         time:(int)time;
/**
 *  @brief      Get device RFID frequency.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)getReaderRFIDFrequency;
/**
 *  @brief      Set device RFID frequency.
 *  @param      frequency      :  The enumeration 'AsP52NRFIDFrequencyStatus'.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)setReaderRFIDFrequency:(AsP52NRFIDFrequencyStatus)frequency;
/**
 *  @brief      Get device RFID frequency list.
 *
 *  @return     Device RFID frequency list.
 */
- (NSArray *)getReaderRFIDFrequencyList:(AsP52NRFIDFrequencyStatus)frequency;
/**
 *  @brief      Get device tag Log.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)getReaderTagLog;
/**
 *  @brief      Set device tag Log.
 *  @param      filtertime      :   Duplicate label filtering time.(0~65535)
 *
 *  @param      rssi      :  RSSI threshold.(-110~0)
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)setReaderTagLogFilterTime:(int)filtertime
                             RSSI:(int)rssi;
/**
 *  @brief      Get device frequency.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)getReaderFrequency;
/**
 *  @brief      Set device frequency.
 *  @param      frequencyAutomatic      :   Whether to use frequency automatic.
 *                                       YES:Used.
 *                                       NO :Don't used.
 *
 *  @param      frequencyList      :  Frequency list.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)setReaderFrequencyAutomatic:(BOOL)frequencyAutomatic
                      frequencyList:(NSString *)frequencyList;
/**
 *  @brief      Get Ethernet MAC Address.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)getReaderEthernetMacAddress;
/**
 *  @brief      Get Reader time.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)getReaderTime;
/**
 *  @brief      Set Reader time.
 *  @param      readerTime      :  Reader time.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)setReaderTime:(long)readerTime;
/**
 *  @brief      Get Ethernet IP.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)getReaderEthernetIP;
/**
 *  @brief      Set Ethernet IP.
 *  @param      ip      :  IP address.
 *
 *  @param      subnetMask      :  Subnet mask.
 *
 *  @param      defaultGateway      :  Default gateway.
 *
 *  @param      preferredDNS      :  Preferred DNS.
 *
 *  @param      alternateDNS      :  Alternate DNS.
 *
 *  @param      automaticIP      :   Whether to set IP automatically.
 *                                 YES:automatic.
 *                                 NO :Static.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)setReaderEthernetIP:(NSString *)ip
                 subnetMask:(NSString *)subnetMask
             defaultGateway:(NSString *)defaultGateway
               preferredDNS:(NSString *)preferredDNS
               alternateDNS:(NSString *)alternateDNS
                automaticIP:(BOOL)automaticIP;
/**
 *  @brief      Factory reset.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)factoryReset;
/**
 *  @brief      Restart the device.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)restartDevice;
/**
 *  @brief      Get the device temperature.
 *
 *  @return     Successed return YES.
 *              Failure return NO.
 */
- (BOOL)getTemperature;
@end


